from panda3d.core import TextureAttrib, MaterialAttrib, TextureStage

def render_stage_convert(node, modulate = True, normal = True, selector = True, emission = True):
    for node_path in node.find_all_matches('**/+GeomNode'):
        geom_node = node_path.node()
        for index_geom in range(geom_node.get_num_geoms()):

            render_state = geom_node.get_geom_state(index_geom)
            new_render_state = render_state.remove_attrib(TextureAttrib)

            if render_state.has_attrib(MaterialAttrib):
                material = render_state.get_attrib(MaterialAttrib).get_material()
                material.set_twoside(False)
                material.clear_metallic()

                new_render_state = new_render_state.add_attrib(MaterialAttrib.make(material))

            if render_state.has_attrib(TextureAttrib):
                new_texture_attrib = TextureAttrib.make_default()
                texture_attrib = render_state.get_attrib(TextureAttrib)
                count_stages = texture_attrib.get_num_on_stages()
                for index_texture_stage in range(count_stages):
                    texture_stage = texture_attrib.get_on_stage(index_texture_stage)
                    texture = render_state.get_attrib(TextureAttrib).get_on_texture(texture_stage)
                    sampler = render_state.get_attrib(TextureAttrib).get_on_sampler(texture_stage)

                    if modulate:
                        if texture_stage.get_mode() == TextureStage.M_modulate:
                            if texture.get_ram_image_size() > 100:
                                new_texture_attrib = new_texture_attrib.add_on_stage(texture_stage, texture, sampler)
                    if normal:
                        if texture_stage.get_mode() == TextureStage.M_normal:
                            if texture.get_ram_image_size() > 100:
                                new_texture_attrib = new_texture_attrib.add_on_stage(texture_stage, texture, sampler)
                    if selector:
                        if texture_stage.get_mode() == TextureStage.M_selector:
                            if texture.get_ram_image_size() > 100:
                                new_texture_attrib = new_texture_attrib.add_on_stage(texture_stage, texture, sampler)
                    if emission:
                        if texture_stage.get_mode() == TextureStage.M_emission:
                            if texture.get_ram_image_size() > 100:
                                new_texture_attrib = new_texture_attrib.add_on_stage(texture_stage, texture, sampler)

                if new_texture_attrib.get_num_on_stages() > 0:
                    new_render_state = new_render_state.add_attrib(new_texture_attrib)
                geom_node.set_geom_state(index_geom, new_render_state)